package generators;

import java.text.SimpleDateFormat;
import java.util.Date;

public class PriceCalculator {
	
	
	public static double calculatePrice(String LicencePlate, Date date, TollPlaza tollPlaza, boolean tagRead, boolean OCR, boolean heavyVehicle){
		double priceFactor = 1;
		double rebateFactor = 1;
		double heavyVehicleFactor = 1;
		int notRead = 1;
		
		int[] priceFactorTable = tollPlaza.getTimeOfDayPriceFactor();
		SimpleDateFormat sdf = new SimpleDateFormat("HH");
		int hour = Integer.parseInt(sdf.format(date));
		priceFactor = priceFactorTable[modulus(hour,24)];
		if(tagRead) {
			if(tollPlaza.getEnumId() == TollPlazaEnum.KROPPAN_BRU.getValue()){
				rebateFactor = 1;
			}
			else rebateFactor = 1-0.20;
		}
		//If nothing is read, we can't charge anytning..
		if(!OCR && !tagRead){
			notRead = 0;
		}
		if(heavyVehicle){
			heavyVehicleFactor = 2;
		}
		
		return tollPlaza.getPrice()*priceFactor*rebateFactor*heavyVehicleFactor*notRead;
	}
	
	public static int modulus(int a, int b){
		return ((a % b)+b) % b;
	}
	
	public static void main(String[] args) {
		
		TollPlazaList tpl = new TollPlazaList();
//		int[] timeOfDayFactor = tpl.getTollPlazas().get(2).getTimeOfDayPriceFactor();
//		for (int i = 0; i < 24; i++) {
//			System.out.println(i+1 + ": " + timeOfDayFactor[i]);
		System.out.println(calculatePrice("12312423", new Date(System.currentTimeMillis() + (1000*60*2450)), tpl.getTollPlazas().get(TollPlazaEnum.KLETT_707.getValue()), false, true, true));
		System.out.println(calculatePrice("12312423", new Date(), tpl.getTollPlazas().get(5), false, true, true));
		System.out.println(calculatePrice("12312423", new Date(), tpl.getTollPlazas().get(2), false, false, true));
	}
}
