package generators;

import java.util.Random;

public class RandomGenerators {

	/** Generate random integers in a certain range. 
	 * 
	 * @param start integer representing the starting number
	 * @param end integer representing the last number
	 * @param aRandom random seed. Use new random() or new Random(seed) for the same sequence
	 * 
	 */
	public static int randomInteger(int start, int end, Random aRandom){
		if (start > end) {
			throw new IllegalArgumentException("Start cannot exceed End.");
		}
		long range = (long)end - (long)start + 1;
		long fraction = (long)(range * aRandom.nextDouble());
		int randomNumber =  (int)(fraction + start);    

		return randomNumber;
	}


	/** Generate random longs in a certain range. 
	 * 
	 * @param start long representing the starting number
	 * @param end long representing the last number
	 * @param aRandom random seed. Use new random() or new Random(seed) for the same sequence
	 * 
	 */
	public static long randomLong(long x, long y, Random aRandom){
		return x+((long)(aRandom.nextDouble()*(y-x)));
	}
	
	public static void main(String[] args) {
		for (int i = 0; i < 500; i++) {
			System.out.println(randomLong(0L ,5L, new Random()));
		}
	}
}
