package generators;

import java.util.Calendar;
import java.util.Date;
import java.util.Random;

import sql.ClearAndResetDB;

/**
 * TODO: Need to fix the rate/hour. Set to r = 5000 cars / hour.
 * Data found in Statens Vegvesens Hndbok for trafikkberegninger (ex. from p. 23 Trondheim 1983)
 */
public class TimeVariableGenerator {

	public static long time;

	static public final double[] hourOfDayAverages = {0.38, 0.1, 0.08, 0.05, 0.05, 0.18, 0.9, 1.5, 1.9, 1.52, 1.6, 1.5, 1.7, 1.8, 2.0, 2.3, 1.6, 1.35, 1.4, 1.4, 1.35, 1.15, 1, 0.6};
	static public final double[] dayOfWeekAverages = {1.05, 1.07, 1.13, 1.14, 1.13, 0.78, 0.70};
	public static final int factor = 4550;
	/**
	 * 
	 */
	
	private static int mod(int x, int y)
	{
	    int result = x % y;
	    return result < 0? result + y : result;
	}
	
	public void generatePass(int startYear, int startMonth, int startDate, int startHour, int startMinute, int startSecond, int stopYear, int stopMonth, int stopDate, int stopHour, int stopMinute, int stopSecond){
		Calendar start = Calendar.getInstance();
		Calendar stop = Calendar.getInstance();
		start.set(startYear, startMonth, startDate, startHour, startMinute, startSecond);
		stop.set(stopYear, stopMonth, stopDate, stopHour, stopMinute, stopSecond);
		long hourDiff = getHourDifference(start.getTime(), stop.getTime());
		System.out.println(hourDiff);

		TollPlazaPassGenerator tppg = new TollPlazaPassGenerator();
		long tempTime = start.getTimeInMillis();
		for (int i = 0; i <= hourDiff; i++) {
			System.out.println(i + " " + print());
			System.out.println("Hour:" + i % 24 + " Day of Week: " + start.get(Calendar.DAY_OF_WEEK));
			System.out.println(new Date(tempTime));
			System.out.println("-------");
			/**
			 * NB! Calendar.DAY_OF_WEEK: Sunday is the first day of the week (1--> sunday, 2-->monday, .. etc)
			 */
			double cars = hourOfDayAverages[i%24]*dayOfWeekAverages[mod(start.get(Calendar.DAY_OF_WEEK)-2, 7)]*factor;
			long tempStop = tempTime + 1000*60*60;
			int z = 0;
			while(z < cars){
				tppg.produceTollPlazaPass(produceRandomTime(tempTime, tempStop));
				z++;
				tppg.clear();
			}
			tempTime = tempStop;
			start.setTime(new Date(tempTime));
			System.out.println("new start time: " + start.getTime());
		}
		System.out.println("Finished");
	}

	/**
	 * 
	 * @param startDue t
	 * @param stop
	 * @return A random time in the interval (start, stop] (including start, excluding stop)
	 */
	public long produceRandomTime(long start, long stop){
		return RandomGenerators.randomLong(start, stop, new Random());
	}

	public int getHourDifference(Date d1, Date d2){
		int days = (int)( (d2.getTime() - d1.getTime()) /(1000 * 60 * 60 * 24) );
		return days * 24;
	}

	private static String print() {
		return "Time elapsed:"+ (long)(System.currentTimeMillis()-time) / (long) (1000) + " seconds";
	}

	public static void main(String[] args) {
		TimeVariableGenerator gen = new TimeVariableGenerator();
		time = System.currentTimeMillis();
		ClearAndResetDB.resetDatabase();
		gen.generatePass(2013, 0, 1, 0, 0, 1, 2013, 3, 2, 0, 0, 0);
		long time2 = System.currentTimeMillis();
		System.out.println("The operation took " + (time2-time) +" ms which is " + (long)(time2-time)/(long)(1000*60) + " minutes");
	}
}
