package generators;

import java.text.SimpleDateFormat;
import java.util.Date;
import sql.InsertDummyData;

/**
 * 
 * @author Per Kristian J. Fjellby
 *
 *What is needed?
 *
 *PlazaID, LicencePlateNumber, Timestamp, OBE-flag, camera-flag, 
 *
 */
public class TollPlazaPassGenerator {
	InsertDummyData ids = new InsertDummyData();
	String name;
	String coordinates;
	String licencePlate;
	String timestamp;
	double price;
	boolean tagRead = false;
	boolean OCRSuccess = false;
	boolean heavyVehicle = false;
	boolean licencePlateCheck = false;
	TollPlazaList plazalist;
	Date variableDate;
	SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");

	public TollPlazaPassGenerator(){
		plazalist = new TollPlazaList();
	}

	public void produceTollPlazaPass(long time){

		boolean tempTagRead = HasTagProbability.hasAutopass();
		boolean tempOCRSuccess = OCRProbability.OCRSuccess();

		int plazaNumber = PickTollPlazaGenerator.pickTollPlaza();
		TollPlaza randomTollPlaza = plazalist.getTollPlazaByEnumId(plazaNumber);

		name = randomTollPlaza.getName() + "";

		licencePlate = LicencePlateNumberGenerator.generateLicenceNumber();
		heavyVehicle = HeavyVehicleProbability.isHeavyVehicle(licencePlate);

		variableDate = new Date(time);
		timestamp = sdf.format(variableDate);

		if (tempTagRead) {
			tagRead = true;
		}

		if(tempOCRSuccess){
			OCRSuccess = true;
		}

		if(!tagRead && !OCRSuccess){
			licencePlate = "ERROR";
			heavyVehicle = false;
		}
		if(tagRead && !OCRSuccess){
			OCRSuccess = false;
		}
		if(!tagRead && OCRSuccess){
			tagRead = false;
		}

		//---------------PRICE--------------------------------
		price = PriceCalculator.calculatePrice(licencePlate, variableDate, randomTollPlaza, tagRead, OCRSuccess, heavyVehicle);
		ids.queue(name, licencePlate, timestamp, heavyVehicle, price, tagRead, OCRSuccess);
	}
	
	public void clear(){
		this.name = null;
		this.coordinates = null;
		this.licencePlate = null;
		this.timestamp = null;
		this.price = 0;
		this.tagRead = false;
		this.OCRSuccess = false;
		this.heavyVehicle = false;
		this.licencePlateCheck = false;
	}

	public static void main(String[] args) throws InterruptedException {
		TollPlazaPassGenerator test = new TollPlazaPassGenerator();
		System.out.println("start");
		test.produceTollPlazaPass(45453434564L);
		System.out.println("Stop");
	}
}
