package graph;

import org.jfree.chart.JFreeChart;
import java.awt.Color;
import java.awt.Font;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import javax.swing.JFrame;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.ChartUtilities;
import org.jfree.chart.axis.DateAxis;
import org.jfree.chart.plot.PiePlot3D;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.XYItemRenderer;
import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;
import org.jfree.data.general.DefaultPieDataset;
import org.jfree.data.general.PieDataset;
import org.jfree.data.xy.XYDataset;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;
import org.jfree.ui.RectangleInsets;
import javax.swing.JPanel;
import org.jfree.data.time.Month;
import org.jfree.data.time.TimeSeries;
import org.jfree.data.time.TimeSeriesCollection;
import org.jfree.ui.ApplicationFrame;
import org.jfree.ui.HorizontalAlignment;
import org.jfree.ui.RectangleEdge;
import org.jfree.ui.RefineryUtilities;
import org.jfree.ui.VerticalAlignment;
import org.jfree.chart.*;
import org.jfree.data.category.*;
import org.jfree.data.xy.*;
import org.jfree.data.*;
import org.jfree.chart.renderer.category.*;
import org.jfree.chart.title.TextTitle;
import org.jfree.chart.plot.*;
import java.awt.*;
import java.io.File;
import java.io.IOException;

import sql.DatabaseRequest;

public class DrawPassesPerHour extends JFrame{
	private static final long serialVersionUID = 1L;

	String[] tollPlazas;

	public String[] getTollPlazas(){
		return this.tollPlazas;
	}

	String startTime;

	public String getStartTime(){
		return this.startTime;
	}

	String stopTime;

	public String getStopTime(){
		return this.stopTime;
	}

	private JFreeChart chart;

	public JFreeChart getChart(){
		return this.chart;
	}

	static long lastEntry;
	static SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
	static SimpleDateFormat guiSDF = new SimpleDateFormat("yyyy-MM-dd");

	public void start(String chartTitle, String start, String stop, String tollString){
		CategoryDataset dataset = null;
		try {
			dataset = createDataset(sdf.parse(start).getTime(), sdf.parse(stop).getTime(), tollString);
		} catch (ParseException e1) {
			e1.printStackTrace();
		}
		JFreeChart chart = createChart(dataset, chartTitle);
		ChartPanel chartPanel = new ChartPanel(chart);
		//			chartPanel.setPreferredSize(new java.awt.Dimension(500, 270));
		setContentPane(chartPanel);
		String dates = ("Data from: " + guiSDF.format(new Date(lastEntry)));
		chart.addSubtitle(new TextTitle(dates, new Font("Dialog", Font.PLAIN, 12), Color.black, RectangleEdge.BOTTOM, HorizontalAlignment.CENTER, VerticalAlignment.BOTTOM, RectangleInsets.ZERO_INSETS));

		this.chart = chart;

		//save file 
		File file = new File("src/pics/passesPerhour.png");
		try {
			ChartUtilities.saveChartAsPNG(file, chart, 500, 270);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public DrawPassesPerHour(String applicationTitle, String chartTitle) {
		super(applicationTitle);
	}

	/** * Creates a sample dataset */
	private static CategoryDataset createDataset(long start, long stop, String tollString) {
		DefaultCategoryDataset dataset = new DefaultCategoryDataset();
		int nil = 0;
		int one = 0;
		int two = 0;
		int three = 0;
		int four = 0;
		int five = 0;
		int six = 0;
		int seven = 0;
		int eight = 0;
		int nine = 0;
		int ten = 0;
		int eleven = 0;
		int twelve = 0;
		int thirteen = 0;
		int fourteen = 0;
		int fifteen = 0;
		int sixteen = 0;
		int seventeen = 0;
		int eighteen = 0;
		int nineteen = 0;
		int twenty = 0;
		int twentyone = 0;
		int twentytwo = 0;
		int twentythree = 0;
		String query = "SELECT timestamp FROM AutoPASS WHERE timestamp < " + sdf.format(stop) + " AND timestamp > " + sdf.format(start) + tollString + " ORDER BY AutoPASS.timestamp ASC";
		System.out.println(query);
		ResultSet rs = DatabaseRequest.issueQuery(query);
		try {
			while(rs.next()){
				String temp = rs.getString(1);
				Date d = null;
				try {
					d = sdf.parse(temp);
				} catch (ParseException e) {
					e.printStackTrace();
				}
				long time = d.getTime();
				lastEntry = time;
				
				Calendar c = new GregorianCalendar();
				c.setTimeInMillis(time);
				int hour = c.get(Calendar.HOUR_OF_DAY);
				switch (hour) {
				case 0:
					nil++;
					break;
				case 1:
					one++;
					break;
				case 2:
					two++;
					break;
				case 3:
					three++;
					break;
				case 4:
					four++;
					break;
				case 5:
					five++;
					break;
				case 6:
					six++;
					break;
				case 7:
					seven++;
					break;
				case 8:
					eight++;
					break;
				case 9:
					nine++;
					break;
				case 10:
					ten++;
					break;
				case 11:
					eleven++;
					break;
				case 12:
					twelve++;
					break;
				case 13:
					thirteen++;
					break;
				case 14:
					fourteen++;
					break;
				case 15:
					fifteen++;
					break;
				case 16:
					sixteen++;
					break;
				case 17:
					seventeen++;
					break;
				case 18:
					eighteen++;
					break;
				case 19:
					nineteen++;
					break;
				case 20:
					twenty++;
					break;
				case 21:
					twentyone++;
					break;
				case 22:
					twentytwo++;
					break;
				case 23:
					twentythree++;
					break;
				default:
					break;
				}
			}
			dataset.addValue(nil, "Hour of Day", "0");
			dataset.addValue(one, "Hour of Day", "1");
			dataset.addValue(two, "Hour of Day", "2");
			dataset.addValue(three, "Hour of Day", "3");
			dataset.addValue(four, "Hour of Day", "4");
			dataset.addValue(five, "Hour of Day", "5");
			dataset.addValue(six, "Hour of Day", "6");
			dataset.addValue(seven, "Hour of Day", "7");
			dataset.addValue(eight, "Hour of Day", "8");
			dataset.addValue(nine, "Hour of Day", "9");
			dataset.addValue(ten, "Hour of Day", "10");
			dataset.addValue(eleven, "Hour of Day", "11");
			dataset.addValue(twelve, "Hour of Day", "12");
			dataset.addValue(thirteen, "Hour of Day", "13");
			dataset.addValue(fourteen, "Hour of Day", "14");
			dataset.addValue(fifteen, "Hour of Day", "15");
			dataset.addValue(sixteen, "Hour of Day", "16");
			dataset.addValue(seventeen, "Hour of Day", "17");
			dataset.addValue(eighteen, "Hour of Day", "18");
			dataset.addValue(nineteen, "Hour of Day", "19");
			dataset.addValue(twenty, "Hour of Day", "20");
			dataset.addValue(twentyone, "Hour of Day", "21");
			dataset.addValue(twentytwo, "Hour of Day", "22");
			dataset.addValue(twentythree, "Hour of Day", "23");

			rs.close();
			return dataset;

		} catch (SQLException e) {
			e.printStackTrace();
		}
		return null;
	}

	public void initialize(){
		ResultSet rs = DatabaseRequest.issueQuery("SELECT DISTINCT name FROM AutoPASS");
		ArrayList<String> array = new ArrayList<String>();
		try {
			while(rs.next()){
				array.add(rs.getString(1));
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		String[] stringArray = array.toArray(new String[array.size()-1]);
		for (int i = 0; i < stringArray.length; i++) {
			System.out.println(stringArray[i]);
		}
		this.tollPlazas = stringArray;

		ResultSet start = DatabaseRequest.issueQuery("SELECT timestamp FROM AutoPASS ORDER BY timestamp ASC LIMIT 1;");
		try {
			start.next();
			startTime = start.getString(1);
		} catch (SQLException e) {
			e.printStackTrace();
		}

		ResultSet stop = DatabaseRequest.issueQuery("SELECT timestamp FROM AutoPASS ORDER BY timestamp DESC LIMIT 1;");
		try {
			stop.next();
			stopTime = stop.getString(1);
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}



	/** * Creates a chart */

	private JFreeChart createChart(CategoryDataset dataset, String title) {
		final JFreeChart chart = ChartFactory.createBarChart(
				"Passes per hour",         // chart title
				"Hour",               // domain axis label
				"Passes",                  // range axis label
				dataset,                  // data
				PlotOrientation.VERTICAL, // orientation
				true,                     // include legend
				true,                     // tooltips?
				false                     // URLs?
				);
		CategoryPlot plot = (CategoryPlot) chart.getPlot();
		plot.setBackgroundPaint(Color.white);
		plot.setRangeGridlinePaint(Color.black);
		BarRenderer barRenderer = (BarRenderer)plot.getRenderer();
		barRenderer.setSeriesPaint(0, Color.BLACK);
		return chart;
	}


	public static void main(String[] args) {
		Calendar c = new GregorianCalendar();
		c.set(2013, 0, 0, 0, 0);
		DrawPassesPerHour demo = new DrawPassesPerHour("Comparison", "Which operating system are you using?");
		//			demo.start("Passes Per Hour", c.getTimeInMillis(), c.getTimeInMillis()+1000*60*60*24);
		demo.pack();
		demo.setVisible(true);
	}
} 
