package graph;

import org.jfree.chart.JFreeChart;
import java.awt.Color;
import java.awt.Font;
import java.io.File;
import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Comparator;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;
import java.util.SortedMap;
import java.util.TreeMap;

import javax.swing.JFrame;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.ChartUtilities;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.category.*;
import org.jfree.ui.HorizontalAlignment;
import org.jfree.ui.RectangleEdge;
import org.jfree.ui.RectangleInsets;
import org.jfree.ui.VerticalAlignment;
import org.jfree.chart.renderer.category.*;
import org.jfree.chart.title.TextTitle;
import org.jfree.chart.plot.*;
import sql.DatabaseRequest;

	public class UnregisteredPassesPerDay extends JFrame{

		private static final long serialVersionUID = 1L;

	static long lastEntry;
	static long firstEntry;
	private JFreeChart chart;
	static SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
	
	public JFreeChart getChart(){
		return this.chart;
	}
		
		  static Comparator<String> betterComparator = new Comparator<String>() {
		        @Override public int compare(String s1, String s2) {
		        	String[] s1Splitt = s1.split("\\.");
		        	String[] s2Splitt = s2.split("\\.");
		        	
		        	if(Integer.parseInt(s1Splitt[2]) < Integer.parseInt(s2Splitt[2])){
		        		return -1;
		        	}
		        	else if(Integer.parseInt(s1Splitt[2]) == Integer.parseInt(s2Splitt[2])){
		        		if(Integer.parseInt(s1Splitt[1]) < Integer.parseInt(s2Splitt[1])){
		        			return -1;
		        		}
		        		else if(Integer.parseInt(s1Splitt[1]) == Integer.parseInt(s2Splitt[1])){
		        			if(Integer.parseInt(s1Splitt[0]) < Integer.parseInt(s2Splitt[0])){
		        				return -1;
		        			}
		        			else if(Integer.parseInt(s1Splitt[0]) == Integer.parseInt(s2Splitt[0])){
		        				return 0;
		        			}
		        			else {
		        				return 1;
		        			}
		        		}
		        		else {
		        			return 1;
		        		}
		        	}
		        	else { 
		        		return 1;
		        	}
		        }           
		    };
		    
		    
		    public void start(String start, String stop, String sqlString){
		    	CategoryDataset dataset = null;
				try {
					dataset = createDataset(sdf.parse(start).getTime(), sdf.parse(stop).getTime(), sqlString);
				} catch (ParseException e1) {
					e1.printStackTrace();
				}
				JFreeChart chart = createChart(dataset);
				ChartPanel chartPanel = new ChartPanel(chart);
//				chartPanel.setPreferredSize(new java.awt.Dimension(500, 270));
				setContentPane(chartPanel);
				SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
				String dates = "From: " + sdf.format(new Date(firstEntry)) + " To: " + sdf.format(new Date(lastEntry));
				chart.addSubtitle(new TextTitle(dates, new Font("Dialog", Font.PLAIN, 12), Color.black, RectangleEdge.BOTTOM, HorizontalAlignment.CENTER, VerticalAlignment.BOTTOM, RectangleInsets.ZERO_INSETS));	
				this.chart = chart;
				//save file
				File file = new File("src/pics/unregisteredPassesPerDay.png");
				try {
					ChartUtilities.saveChartAsPNG(file, chart, 800, 800);
				} catch (IOException e) {
					e.printStackTrace();
				}
		    }

		public UnregisteredPassesPerDay(String applicationTitle) {
			super(applicationTitle);
		}

		/** * Creates a sample dataset */
		private static CategoryDataset createDataset(long start, long stop, String sqlString) {
			DefaultCategoryDataset dataset = new DefaultCategoryDataset();
			Calendar cal = new GregorianCalendar();
//			SELECT timestamp FROM `AutoPASS` WHERE hasTag = 0 and OCRsuccess = 0 AND timestamp < 20130106220534 ORDER BY AutoPASS.timestamp ASC
			String query = "SELECT timestamp FROM `AutoPASS` WHERE hasTag = 0 and OCRsuccess = 0 AND timestamp < " + sdf.format(new Date(stop)) + " AND timestamp > " + sdf.format(new Date(start)) + sqlString + " ORDER BY AutoPASS.timestamp ASC";
			ResultSet rs = DatabaseRequest.issueQuery(query);
			try {
				Map<String, Integer> map = new HashMap<String, Integer>();
				String[] key;
				Integer[] value;
				int i = 0;
				while(rs.next()){
					String temp1 = rs.getString(1);
					Date d = null;
					try {
						d = sdf.parse(temp1);
					} catch (ParseException e) {
						e.printStackTrace();
					}
					long time = d.getTime();
					Calendar c = new GregorianCalendar();
					c.setTimeInMillis(time);
					int day = c.get(Calendar.DAY_OF_MONTH);
					int month = c.get(Calendar.MONTH);
					int year = c.get(Calendar.YEAR);
					
					String tag = day+"."+month+"."+year;
					if(map.containsKey(tag)){
						int temp = map.get(tag);
						System.out.println(temp);
						map.put(tag, ++temp);
						System.out.println("found");
					}
					else{
						map.put(tag, new Integer(1));
						System.out.println("not found");
					}
				}
				
				SortedMap<String, Integer> sortedMap = new TreeMap<String, Integer>(betterComparator);
				sortedMap.putAll(map);
				Iterator<Entry<String, Integer>> it = sortedMap.entrySet().iterator();
				while(it.hasNext()){
					Map.Entry<String, Integer> pairs = (Entry<String, Integer>) it.next();
					String date = pairs.getKey();
					String[] split = date.split("\\.");
					for (String string : split) {
						System.out.println(string);
						cal.set(Integer.parseInt(split[2]), Integer.parseInt(split[1]), Integer.parseInt(split[0]));
						date = "" + cal.get(Calendar.DAY_OF_MONTH);
						if(i < 1){
							firstEntry = cal.getTimeInMillis();
							i++;
						}
						dataset.addValue(pairs.getValue(), "Day", date);
					}
				}
				lastEntry = cal.getTimeInMillis();
				return dataset;
			} catch (SQLException e) {
				e.printStackTrace();
			}
			return null;
		}

		/** * Creates a chart */

		private JFreeChart createChart(CategoryDataset dataset) {
			 final JFreeChart chart = ChartFactory.createBarChart(
			            "Unregistered Passes Per Day",         // chart title
			            "Day",               // domain axis label
			            "Unregistered Passes",                  // range axis label
			            dataset,                  // data
			            PlotOrientation.VERTICAL, // orientation
			            true,                     // include legend
			            true,                     // tooltips?
			            false                     // URLs?
			        );
			 CategoryPlot plot = (CategoryPlot) chart.getPlot();
			 plot.setBackgroundPaint(Color.white);
			 plot.setRangeGridlinePaint(Color.black);
			 BarRenderer barRenderer = (BarRenderer)plot.getRenderer();
			 barRenderer.setSeriesPaint(0, Color.BLACK);
			 return chart;
		}

		public static void main(String[] args) {
			Calendar c = new GregorianCalendar();
			c.set(2013, 0, 0, 0, 0);
//			UnregisteredPassesPerDay demo = new UnregisteredPassesPerDay("Comparison", c.getTimeInMillis(), c.getTimeInMillis()+1000*60*60*24L*60);
//			demo.pack();
//			demo.setVisible(true);
		}
	} 
