package gui;

import java.awt.BorderLayout;
import java.awt.Dimension;

import graph.DrawPassesPerDayOfWeek;
import graph.DrawPassesPerHour;
import graph.TollString;
import graph.UnregisteredPassesPerDay;
import graph.UnregisteredPassesPerTollPlaza;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.SwingWorker;

import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;

public class Worker extends SwingWorker<JFreeChart, JFreeChart>{


	public JFrame frame;
	public JPanel entirePanel;
	public JPanel headerPanel;
	int typeOfChart;
	String startString;
	String stopString;
	String sqlString;

	DrawPassesPerDayOfWeek passesPerDayOfWeek = new DrawPassesPerDayOfWeek("Passes per day of week", "Passes per day of week");
	DrawPassesPerHour passesPerHour = new DrawPassesPerHour("Passes per hour", "Passes per hour");
	UnregisteredPassesPerDay passesPerDay = new UnregisteredPassesPerDay("Unregistered passes per day");
	UnregisteredPassesPerTollPlaza unregisteredPassesPerTollPlaza = new UnregisteredPassesPerTollPlaza("Unregistered passes per toll plaza");

	public Worker(JFrame f, JPanel entirePanel, JPanel headerPanel, int typeOfChart, String startString, String stopString, String sqlString){
		this.frame = f;
		this.entirePanel = entirePanel;
		this.headerPanel = headerPanel;
		this.typeOfChart = typeOfChart;
		this.startString = startString;
		this.stopString = stopString;
		this.sqlString = sqlString;
	}

	protected JFreeChart doInBackground() throws Exception {
		JFreeChart chart = null;
		if(typeOfChart == 1){
			System.out.println("TRUE!");
			passesPerDayOfWeek.start("Passes per day of the week", startString, stopString, TollString.sqlString);
			chart = passesPerDayOfWeek.getChart();
		}
		else if(typeOfChart == 2){
			passesPerHour.start("Passes per hour", startString, stopString, TollString.sqlString);
			chart = passesPerHour.getChart();
		}
		else if(typeOfChart == 3){
			//Unregistered passes per day
			passesPerDay.start(startString, stopString, TollString.sqlString);
			chart = passesPerDay.getChart();
		}
		else if(typeOfChart == 4){
			unregisteredPassesPerTollPlaza.start(startString, stopString, TollString.sqlString);
			chart = unregisteredPassesPerTollPlaza.getChart();
			//			Unregistered passes per toll plaza
		}

		return chart;
	}

	protected void done()
	{
		try
		{
			ChartPanel chartPanel = new ChartPanel(get());
			chartPanel.setSize(new Dimension(1024, 1024));
			chartPanel.setLayout(new BorderLayout());
			entirePanel.removeAll();
			entirePanel.add(headerPanel);
			entirePanel.add(chartPanel, BorderLayout.SOUTH);
			entirePanel.validate();
			frame.pack();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}

}
