package sql;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Queue;
public class InsertDummyData {

	public class TemporaryStringHandler {
		String name;
		String licencePlate;
		String timestamp;
		boolean heavyVehicle;
		double price;
		boolean tagRead;
		boolean OCRsuccess;

		public TemporaryStringHandler(String name, String licencePlate, String timestamp, boolean heavyVehicle, double price, boolean tagRead, boolean OCRSuccess) {
			this.name = name;
			this.licencePlate = licencePlate;
			this.timestamp = timestamp;
			this.heavyVehicle = heavyVehicle;
			this.price = price;
			this.tagRead = tagRead;
			this.OCRsuccess = OCRSuccess;
		}

		public String getName() {
			return name;
		}

		public String getLicencePlate() {
			return licencePlate;
		}

		public String getTimestamp() {
			return timestamp;
		}

		public boolean isHeavyVehicle() {
			return heavyVehicle;
		}

		public double getPrice() {
			return price;
		}

		public boolean isTagRead() {
			return tagRead;
		}

		public boolean isOCRsuccess() {
			return OCRsuccess;
		}
	}


	private int i;
	private ArrayList<TemporaryStringHandler> queue;

	String sqlQuery = "INSERT INTO AutoPASS(name, timestamp, heavyVehicle, price, hasTag, OCRsuccess) VALUES(?,?,?,?,?,?)";

	public int geti(){
		return this.i;
	}

	public InsertDummyData(){
		queue = new ArrayList<TemporaryStringHandler>(100000);
	}

	/**
	 * This method should queue up data and regularly push it to the DB
	 */
	public void queue(String name, String licencePlate, String timestamp, boolean heavyVehicle, double price, boolean tagRead, boolean OCRSuccess){
		queue.add(new TemporaryStringHandler(name, licencePlate, timestamp, heavyVehicle, price, tagRead, OCRSuccess));
		if(queue.size()%100000 == 0){
			System.out.println("Writing to database!");
			//			new Thread(
			//					new Runnable() {
			//						public void run() {
			//							try {
			//								if(insert(queue)){
			//								}
			//							} catch (Exception e) {
			//								e.printStackTrace();
			//							}
			//						}
			//					}).start();
			try {
				if(insert(queue)){
					queue.clear();
				}
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
	}
	//else continue without flushing the queue, and write on next occasion

	public boolean insert(ArrayList<TemporaryStringHandler> queue) throws SQLException{
		Connection con = null;
		con = SqlConnection.connect();

		/*
		 * Trying to speed up things by locking the table for writes
		 */

//		//		Make sure no locks hang..
//		PreparedStatement writeUnlock = con.prepareStatement("UNLOCK TABLES;");
//		writeUnlock.execute();
//		//		set lock
//		PreparedStatement writeLock = con.prepareStatement("LOCK TABLES AutoPASS WRITE;");
//		writeLock.execute();

		PreparedStatement pres = con.prepareStatement(sqlQuery);

		//Need to iterate over the queue and write every instance to the DB

		Iterator<TemporaryStringHandler> it = queue.iterator();

		while(it.hasNext()){
			TemporaryStringHandler tsh = it.next();
			pres.setString(1, tsh.getName());
//			pres.setString(2, tsh.getLicencePlate());
			pres.setString(2, tsh.getTimestamp());
			pres.setBoolean(3, tsh.isHeavyVehicle());
			pres.setDouble(4, tsh.getPrice());
			pres.setBoolean(5, tsh.isTagRead());
			pres.setBoolean(6, tsh.isOCRsuccess());
			pres.addBatch();
		}
		int[] successArray = pres.executeBatch();
		boolean success = true;
		for (int i = 0; i < successArray.length; i++) {
			if(successArray[i] < 0){
				success = false;
				break;
			}
		}
		pres.clearBatch();
		pres.clearParameters();
		pres.close();
		con.close();

		return success;
	}
}
